diff -ruN vdr-1.3.24/skinsttng.c vdr-1.3.25/skinsttng.c
--- vdr-1.3.24/skinsttng.c	2005-02-27 15:45:19.000000000 +0100
+++ vdr-1.3.25/skinsttng.c	2005-05-16 12:44:58.000000000 +0200
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: skinsttng.c 1.13 2005/02/27 14:45:19 kls Exp $
+ * $Id: skinsttng.c 1.14 2005/05/16 10:44:58 kls Exp $
  */
 
 // Star Trek: The Next Generation® is a registered trademark of Paramount Pictures
@@ -576,7 +576,39 @@
 
 void cSkinSTTNGDisplayMenu::SetRecording(const cRecording *Recording)
 {
-  SetText(Recording->Summary(), false); //XXX
+  if (!Recording)
+     return;
+  const cRecordingInfo *Info = Recording->Info();
+  const cFont *font = cFont::GetFont(fontOsd);
+  int xl = x3 + 5;
+  int y = y3;
+  cTextScroller ts;
+  char t[32];
+  snprintf(t, sizeof(t), "%s  %s", *DateString(Recording->start), *TimeString(Recording->start));
+  ts.Set(osd, xl, y, x4 - xl, y4 - y, t, font, Theme.Color(clrMenuEventTime), Theme.Color(clrBackground));
+  y += ts.Height();
+  y += font->Height();
+  const char *Title = Info->Title();
+  if (isempty(Title))
+     Title = Recording->Name();
+  ts.Set(osd, xl, y, x4 - xl, y4 - y, Title, font, Theme.Color(clrMenuEventTitle), Theme.Color(clrBackground));
+  y += ts.Height();
+  if (!isempty(Info->ShortText())) {
+     const cFont *font = cFont::GetFont(fontSml);
+     ts.Set(osd, xl, y, x4 - xl, y4 - y, Info->ShortText(), font, Theme.Color(clrMenuEventShortText), Theme.Color(clrBackground));
+     y += ts.Height();
+     }
+  y += font->Height();
+  if (!isempty(Info->Description())) {
+     int yt = y;
+     int yb = y4 - Roundness;
+     textScroller.Set(osd, xl, yt, x4 - xl, yb - yt, Info->Description(), font, Theme.Color(clrMenuEventDescription), Theme.Color(clrBackground));
+     yb = yt + textScroller.Height();
+     osd->DrawEllipse  (x1, yt - Roundness, x2, yt,             frameColor, -3);
+     osd->DrawRectangle(x1, yt,             x2, yb,             frameColor);
+     osd->DrawEllipse  (x1, yb,             x2, yb + Roundness, frameColor, -2);
+     SetScrollbar();
+     }
 }
 
 void cSkinSTTNGDisplayMenu::SetText(const char *Text, bool FixedFont)
diff -ruN vdr-1.3.24/sources.h vdr-1.3.25/sources.h
--- vdr-1.3.24/sources.h	2004-12-26 12:59:21.000000000 +0100
+++ vdr-1.3.25/sources.h	2005-05-14 11:30:41.000000000 +0200
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: sources.h 1.3 2004/12/26 11:59:21 kls Exp $
+ * $Id: sources.h 1.4 2005/05/14 09:30:41 kls Exp $
  */
 
 #ifndef __SOURCES_H
@@ -35,6 +35,9 @@
   static cString ToString(int Code);
   static int FromString(const char *s);
   static int FromData(eSourceType SourceType, int Position = 0, bool East = false);
+  static bool IsCable(int Code) { return (Code & st_Mask) == stCable; }
+  static bool IsSat(int Code) { return (Code & st_Mask) == stSat; }
+  static bool IsTerr(int Code) { return (Code & st_Mask) == stTerr; }
   };
 
 class cSources : public cConfig<cSource> {
diff -ruN vdr-1.3.24/summary2info.pl vdr-1.3.25/summary2info.pl
--- vdr-1.3.24/summary2info.pl	1970-01-01 01:00:00.000000000 +0100
+++ vdr-1.3.25/summary2info.pl	2005-05-22 12:37:47.000000000 +0200
@@ -0,0 +1,47 @@
+#!/usr/bin/perl
+
+# Convert 'summary.vdr' files to 'info.vdr'
+#
+# Converts all 'summary.vdr' files in the video directory to the
+# 'info.vdr' format as used from VDR version 1.3.25 upward.
+#
+# Usage: summary2info.pl /video
+#
+# See the main source file 'vdr.c' for copyright information and
+# how to reach the author.
+#
+# $Id: summary2info.pl 1.2 2005/05/22 10:37:47 kls Exp $
+
+$VideoDir = $ARGV[0] || die "please provide the name of the video directory\n";
+
+@SummaryFiles = `find "$VideoDir" -name summary.vdr`;
+
+for $SummaryFile (@SummaryFiles) {
+    chomp($SummaryFile);
+    print STDERR "converting $SummaryFile...";
+    open(F, $SummaryFile) || die "$SummaryFile: $!\n";
+    $line = 0;
+    @data = ();
+    while (<F>) {
+          chomp;
+          if ($_) {
+             $data[$line] .= '|' if ($data[$line]);
+             $data[$line] .= $_;
+             }
+          else {
+             $line++;
+             }
+          }
+    close(F);
+    if ($line == 1) {
+       $data[2] = $data[1];
+       $data[1] = "";
+       }
+    ($InfoFile = $SummaryFile) =~ s/summary\.vdr$/info.vdr/;
+    open(F, ">$InfoFile") || die "$InfoFile: $!\n";
+    print F "T $data[0]\n" if ($data[0]);
+    print F "S $data[1]\n" if ($data[1]);
+    print F "D $data[2]\n" if ($data[2]);
+    close(F);
+    print STDERR "done.\n";
+    }
diff -ruN vdr-1.3.24/svdrp.c vdr-1.3.25/svdrp.c
--- vdr-1.3.24/svdrp.c	2005-05-06 15:47:39.000000000 +0200
+++ vdr-1.3.25/svdrp.c	2005-05-26 11:59:09.000000000 +0200
@@ -10,7 +10,7 @@
  * and interact with the Video Disk Recorder - or write a full featured
  * graphical interface that sits on top of an SVDRP connection.
  *
- * $Id: svdrp.c 1.70 2005/05/06 13:47:39 kls Exp $
+ * $Id: svdrp.c 1.72 2005/05/26 09:59:09 kls Exp $
  */
 
 #include "svdrp.h"
@@ -31,6 +31,7 @@
 #include "device.h"
 #include "eitscan.h"
 #include "keys.h"
+#include "menu.h"
 #include "remote.h"
 #include "timers.h"
 #include "tools.h"
@@ -214,7 +215,7 @@
   "    events at the given time (which must be in time_t form).",
   "LSTR [ <number> ]\n"
   "    List recordings. Without option, all recordings are listed. Otherwise\n"
-  "    the summary for the given recording is listed.",
+  "    the information for the given recording is listed.",
   "LSTT [ <number> ]\n"
   "    List timers. Without option, all timers are listed. Otherwise\n"
   "    only the given timer is listed.",
@@ -281,7 +282,7 @@
 /* SVDRP Reply Codes:
 
  214 Help message
- 215 EPG data record
+ 215 EPG or recording data record
  220 VDR service ready
  221 VDR service closing transmission channel
  250 Requested VDR action okay, completed
@@ -505,12 +506,17 @@
      if (isnumber(Option)) {
         cRecording *recording = Recordings.Get(strtol(Option, NULL, 10) - 1);
         if (recording) {
-           if (recording->Delete()) {
-              Reply(250, "Recording \"%s\" deleted", Option);
-              ::Recordings.Load(); // must make sure the global recordings list is updated
+           cRecordControl *rc = cRecordControls::GetRecordControl(recording->FileName());
+           if (!rc) {
+              if (recording->Delete()) {
+                 Reply(250, "Recording \"%s\" deleted", Option);
+                 ::Recordings.Load(); // must make sure the global recordings list is updated
+                 }
+              else
+                 Reply(554, "Error while deleting recording!");
               }
            else
-              Reply(554, "Error while deleting recording!");
+              Reply(550, "Recording \"%s\" is in use by timer %d", Option, rc->Timer()->Index() + 1);
            }
         else
            Reply(550, "Recording \"%s\" not found%s", Option, Recordings.Count() ? "" : " (use LSTR before deleting)");
@@ -800,13 +806,15 @@
      if (isnumber(Option)) {
         cRecording *recording = Recordings.Get(strtol(Option, NULL, 10) - 1);
         if (recording) {
-           if (recording->Summary()) {
-              char *summary = strdup(recording->Summary());
-              Reply(250, "%s", strreplace(summary,'\n','|'));
-              free(summary);
+           FILE *f = fdopen(file, "w");
+           if (f) {
+              recording->Info()->Write(f, "215-");
+              fflush(f);
+              Reply(215, "End of recording information");
+              // don't 'fclose(f)' here!
               }
            else
-              Reply(550, "No summary available");
+              Reply(451, "Can't open file connection");
            }
         else
            Reply(550, "Recording \"%s\" not found", Option);
diff -ruN vdr-1.3.24/thread.c vdr-1.3.25/thread.c
--- vdr-1.3.24/thread.c	2005-05-06 16:39:15.000000000 +0200
+++ vdr-1.3.25/thread.c	2005-05-29 13:40:30.000000000 +0200
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: thread.c 1.42 2005/05/06 14:39:15 kls Exp $
+ * $Id: thread.c 1.43 2005/05/29 11:40:30 kls Exp $
  */
 
 #include "thread.h"
@@ -208,6 +208,12 @@
   free(description);
 }
 
+void cThread::SetPriority(int Priority)
+{
+  if (setpriority(PRIO_PROCESS, 0, Priority) < 0)
+     LOG_ERROR;
+}
+
 void cThread::SetDescription(const char *Description, ...)
 {
   free(description);
diff -ruN vdr-1.3.24/thread.h vdr-1.3.25/thread.h
--- vdr-1.3.24/thread.h	2005-01-14 15:02:14.000000000 +0100
+++ vdr-1.3.25/thread.h	2005-05-29 13:31:24.000000000 +0200
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: thread.h 1.27 2005/01/14 14:02:14 kls Exp $
+ * $Id: thread.h 1.28 2005/05/29 11:31:24 kls Exp $
  */
 
 #ifndef __THREAD_H
@@ -82,6 +82,7 @@
   static bool emergencyExitRequested;
   static void *StartThread(cThread *Thread);
 protected:
+  void SetPriority(int Priority);
   void Lock(void) { mutex.Lock(); }
   void Unlock(void) { mutex.Unlock(); }
   virtual void Action(void) = 0;
diff -ruN vdr-1.3.24/tools.c vdr-1.3.25/tools.c
--- vdr-1.3.24/tools.c	2005-03-20 15:44:33.000000000 +0100
+++ vdr-1.3.25/tools.c	2005-05-29 12:18:26.000000000 +0200
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: tools.c 1.91 2005/03/20 14:44:33 kls Exp $
+ * $Id: tools.c 1.95 2005/05/29 10:18:26 kls Exp $
  */
 
 #include "tools.h"
@@ -571,6 +571,25 @@
   return "???";
 }
 
+cString DateString(time_t t)
+{
+  char buf[32];
+  struct tm tm_r;
+  tm *tm = localtime_r(&t, &tm_r);
+  char *p = stpcpy(buf, WeekDayName(tm->tm_wday));
+  *p++ = ' ';
+  strftime(p, sizeof(buf) - (p - buf), "%d.%m.%Y", tm);
+  return buf;
+}
+
+cString TimeString(time_t t)
+{
+  char buf[25];
+  struct tm tm_r;
+  strftime(buf, sizeof(buf), "%R", localtime_r(&t, &tm_r));
+  return buf;
+}
+
 // --- cReadLine -------------------------------------------------------------
 
 char *cReadLine::Read(FILE *f)
@@ -913,6 +932,7 @@
 cListBase::cListBase(void)
 { 
   objects = lastObject = NULL;
+  count = 0;
 }
 
 cListBase::~cListBase()
@@ -933,6 +953,7 @@
         objects = Object;
      lastObject = Object;
      }
+  count++;
 }
 
 void cListBase::Ins(cListObject *Object, cListObject *Before)
@@ -948,6 +969,7 @@
         lastObject = Object;
      objects = Object;
      }
+  count++;
 }
 
 void cListBase::Del(cListObject *Object, bool DeleteObject)
@@ -959,6 +981,7 @@
   Object->Unlink();
   if (DeleteObject)
      delete Object;
+  count--;
 }
 
 void cListBase::Move(int From, int To)
@@ -998,6 +1021,7 @@
         objects = object;
         }
   objects = lastObject = NULL;
+  count = 0;
 }
 
 cListObject *cListBase::Get(int Index) const
@@ -1010,18 +1034,6 @@
   return object;
 }
 
-int cListBase::Count(void) const
-{
-  int n = 0;
-  cListObject *object = objects;
-
-  while (object) {
-        n++;
-        object = object->Next();
-        }
-  return n;
-}
-
 static int CompareListObjects(const void *a, const void *b)
 {
   const cListObject *la = *(const cListObject **)a;
@@ -1043,7 +1055,60 @@
   objects = lastObject = NULL;
   for (i = 0; i < n; i++) {
       a[i]->Unlink();
+      count--;
       Add(a[i]);
       }
 }
 
+// --- cHashBase -------------------------------------------------------------
+
+cHashBase::cHashBase(int Size)
+{
+  size = Size;
+  hashTable = (cList<cHashObject>**)calloc(size, sizeof(cList<cHashObject>*));
+}
+
+cHashBase::~cHashBase(void)
+{
+  for (int i = 0; i < size; i++)
+      delete hashTable[i];
+  free(hashTable);
+}
+
+void cHashBase::Add(cListObject *Object, unsigned int Id)
+{
+  unsigned int hash = hashfn(Id);
+  if (!hashTable[hash])
+     hashTable[hash] = new cList<cHashObject>;
+  hashTable[hash]->Add(new cHashObject(Object, Id));
+}
+
+void cHashBase::Del(cListObject *Object, unsigned int Id)
+{
+  cList<cHashObject> *list = hashTable[hashfn(Id)];
+  if (list) {
+     for (cHashObject *hob = list->First(); hob; hob = list->Next(hob)) {
+         if (hob->object == Object) {
+            list->Del(hob);
+            break;
+            }
+         }
+     }
+}
+
+cListObject *cHashBase::Get(unsigned int Id) const
+{
+  cList<cHashObject> *list = hashTable[hashfn(Id)];
+  if (list) {
+     for (cHashObject *hob = list->First(); hob; hob = list->Next(hob)) {
+         if (hob->id == Id)
+            return hob->object;
+         }
+     }
+  return NULL;
+}
+
+cList<cHashObject> *cHashBase::GetList(unsigned int Id) const
+{
+  return hashTable[hashfn(Id)];
+}
diff -ruN vdr-1.3.24/tools.h vdr-1.3.25/tools.h
--- vdr-1.3.24/tools.h	2005-03-20 15:44:24.000000000 +0100
+++ vdr-1.3.25/tools.h	2005-05-29 12:24:54.000000000 +0200
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: tools.h 1.68 2005/03/20 14:44:24 kls Exp $
+ * $Id: tools.h 1.72 2005/05/29 10:24:54 kls Exp $
  */
 
 #ifndef __TOOLS_H
@@ -102,6 +102,8 @@
 cString WeekDayName(time_t t);
 cString DayDateTime(time_t t = 0);
 cString TimeToString(time_t t);
+cString DateString(time_t t);
+cString TimeString(time_t t);
 
 class cTimeMs {
 private:
@@ -211,6 +213,7 @@
 protected:
   cListObject *objects, *lastObject;
   cListBase(void);
+  int count;
 public:
   virtual ~cListBase();
   void Add(cListObject *Object, cListObject *After = NULL);
@@ -220,7 +223,7 @@
   void Move(cListObject *From, cListObject *To);
   virtual void Clear(void);
   cListObject *Get(int Index) const;
-  int Count(void) const;
+  int Count(void) const { return count; }
   void Sort(void);
   };
 
@@ -233,4 +236,36 @@
   T *Next(const T *object) const { return (T *)object->cListObject::Next(); } // avoid ambiguities in case of a "list of lists"
   };
 
+class cHashObject : public cListObject {
+  friend class cHashBase;
+private:
+  unsigned int id;
+  cListObject *object;
+public:
+  cHashObject(cListObject *Object, unsigned int Id) { object = Object; id = Id; }
+  };
+
+class cHashBase {
+private:
+  cList<cHashObject> **hashTable;
+  int size;
+  unsigned int hashfn(unsigned int Id) const { return Id % size; }
+protected:
+  cHashBase(int Size);
+public:
+  virtual ~cHashBase();
+  void Add(cListObject *Object, unsigned int Id);
+  void Del(cListObject *Object, unsigned int Id);
+  cListObject *Get(unsigned int Id) const;
+  cList<cHashObject> *GetList(unsigned int Id) const;
+  };
+
+#define HASHSIZE 512
+
+template<class T> class cHash : public cHashBase {
+public:
+  cHash(int Size = HASHSIZE) : cHashBase(Size) {}
+  T *Get(unsigned int Id) const { return (T *)cHashBase::Get(Id); }
+};
+
 #endif //__TOOLS_H
diff -ruN vdr-1.3.24/vdr.c vdr-1.3.25/vdr.c
--- vdr-1.3.24/vdr.c	2005-03-20 11:58:59.000000000 +0100
+++ vdr-1.3.25/vdr.c	2005-05-26 12:45:29.000000000 +0200
@@ -22,7 +22,7 @@
  *
  * The project's page is at http://www.cadsoft.de/vdr
  *
- * $Id: vdr.c 1.203 2005/03/20 10:58:59 kls Exp $
+ * $Id: vdr.c 1.207 2005/05/26 10:45:29 kls Exp $
  */
 
 #include <getopt.h>
@@ -87,25 +87,6 @@
 
 int main(int argc, char *argv[])
 {
-#ifdef _CS_GNU_LIBPTHREAD_VERSION
-  // Check for NPTL and exit if present - VDR apparently doesn't run well with NPTL:
-  char LibPthreadVersion[128];
-  if (confstr(_CS_GNU_LIBPTHREAD_VERSION, LibPthreadVersion, sizeof(LibPthreadVersion)) > 0) {
-     if (strstr(LibPthreadVersion, "NPTL")) {
-        fprintf(stderr, "vdr: please turn off NPTL by setting 'export LD_ASSUME_KERNEL=2.4.1' before starting VDR\n");
-        return 2;
-        }
-     }
-#endif
-
-  // Check for UTF-8 and exit if present - asprintf() will fail if it encounters 8 bit ASCII codes
-  char *LangEnv;
-  if ((LangEnv = getenv("LANG"))     != NULL && strcasestr(LangEnv, "utf") ||
-      (LangEnv = getenv("LC_CTYPE")) != NULL && strcasestr(LangEnv, "utf")) {
-     fprintf(stderr, "vdr: please turn off UTF-8 before starting VDR\n");
-     return 2;
-     }
-
   // Save terminal settings:
 
   struct termios savedTm;
@@ -321,6 +302,25 @@
      return 0;
      }
 
+#ifdef _CS_GNU_LIBPTHREAD_VERSION
+  // Check for NPTL and exit if present - VDR apparently doesn't run well with NPTL:
+  char LibPthreadVersion[128];
+  if (confstr(_CS_GNU_LIBPTHREAD_VERSION, LibPthreadVersion, sizeof(LibPthreadVersion)) > 0) {
+     if (strstr(LibPthreadVersion, "NPTL")) {
+        fprintf(stderr, "vdr: please turn off NPTL by setting 'export LD_ASSUME_KERNEL=2.4.1' before starting VDR\n");
+        return 2;
+        }
+     }
+#endif
+
+  // Check for UTF-8 and exit if present - asprintf() will fail if it encounters 8 bit ASCII codes
+  char *LangEnv;
+  if ((LangEnv = getenv("LANG"))     != NULL && strcasestr(LangEnv, "utf") ||
+      (LangEnv = getenv("LC_CTYPE")) != NULL && strcasestr(LangEnv, "utf")) {
+     fprintf(stderr, "vdr: please turn off UTF-8 before starting VDR\n");
+     return 2;
+     }
+
   // Log file:
 
   if (SysLogLevel > 0)
@@ -744,7 +744,6 @@
           // Power off:
           case kPower: isyslog("Power button pressed");
                        DELETENULL(Menu);
-                       cControl::Shutdown();
                        Temp = NULL;
                        if (!Shutdown) {
                           Skins.Message(mtError, tr("Can't shutdown - option '-s' not given!"));
@@ -846,6 +845,14 @@
                   break;
              // Viewing Control:
              case kOk:   LastChannel = -1; break; // forces channel display
+             // Instant resume of the last viewed recording:
+             case kPlay:
+                  if (cReplayControl::LastReplayed()) {
+                     cControl::Shutdown();
+                     Temp = NULL;
+                     cControl::Launch(new cReplayControl);
+                     }
+                  break;
              // Key macros:
              case kRed:
              case kGreen:
@@ -898,6 +905,7 @@
                     if (WatchdogTimeout > 0)
                        signal(SIGALRM, SIG_IGN);
                     if (Interface->Confirm(tr("Press any key to cancel shutdown"), UserShutdown ? 5 : SHUTDOWNWAIT, true)) {
+                       cControl::Shutdown();
                        int Channel = timer ? timer->Channel()->Number() : 0;
                        const char *File = timer ? timer->File() : "";
                        Delta = Next - time(NULL); // compensates for Confirm() timeout
@@ -940,9 +948,11 @@
   Remotes.Clear();
   Audios.Clear();
   Skins.Clear();
-  Setup.CurrentChannel = cDevice::CurrentChannel();
-  Setup.CurrentVolume  = cDevice::CurrentVolume();
-  Setup.Save();
+  if (ExitCode != 2) {
+     Setup.CurrentChannel = cDevice::CurrentChannel();
+     Setup.CurrentVolume  = cDevice::CurrentVolume();
+     Setup.Save();
+     }
   cDevice::Shutdown();
   PluginManager.Shutdown();
   ReportEpgBugFixStats();
